// Copyright 2024 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

#include "go_asm.h"
#include "textflag.h"

TEXT ·Count<ABIInternal>(SB),NOSPLIT,$0-40
	// R4 = b_base
	// R5 = b_len
	// R6 = b_cap (unused)
	// R7 = byte to count
	AND	$0xff, R7, R6
	JMP	countbody<>(SB)

TEXT ·CountString<ABIInternal>(SB),NOSPLIT,$0-32
	// R4 = s_base
	// R5 = s_len
	// R6 = byte to count
	AND	$0xff, R6
	JMP	countbody<>(SB)

// input:
//   R4 = s_base
//   R5 = s_len
//   R6 = byte to count
TEXT countbody<>(SB),NOSPLIT,$0
	MOVV	R0, R7		// count
	ADDV	R4, R5		// end
	MOVV	$1, R17

loop:
	ADDV	$8, R4, R9
	BLT	R5, R9, tail
	MOVV	(R4), R8

	AND	$0xff, R8, R10
	WORD	$0xcf210b	// bstrpick.w r11, r8, 15, 8
	XOR	R6, R10, R10
	XOR	R6, R11, R11
	MASKNEZ	R10, R17, R12
	MASKNEZ	R11, R17, R13
	ADDV	R7, R12, R7
	ADDV	R7, R13, R7

	WORD	$0xd7410a	// bstrpick.w r10, r8, 23, 16
	WORD	$0xdf610b	// bstrpick.w r11, r8, 31, 24
	XOR	R6, R10, R10
	XOR	R6, R11, R11
	MASKNEZ	R10, R17, R12
	MASKNEZ	R11, R17, R13
	ADDV	R7, R12, R7
	ADDV	R7, R13, R7

	WORD	$0xe7810a	// bstrpick.w r10, r8, 39, 32
	WORD	$0xefa10b	// bstrpick.w r11, r8, 47, 40
	XOR	R6, R10, R10
	XOR	R6, R11, R11
	MASKNEZ	R10, R17, R12
	MASKNEZ	R11, R17, R13
	ADDV	R7, R12, R7
	ADDV	R7, R13, R7

	WORD	$0xf7c10a	// bstrpick.w r10, r8, 55, 48
	WORD	$0xffe10b	// bstrpick.w r11, r8, 63, 56
	XOR	R6, R10, R10
	XOR	R6, R11, R11
	MASKNEZ	R10, R17, R12
	MASKNEZ	R11, R17, R13
	ADDV	R7, R12, R7
	ADDV	R7, R13, R7

	MOVV	R9, R4
	JMP	loop

tail:
	BEQ	R4, R5, done
	MOVBU	(R4), R8
	ADDV	$1, R4
	BNE	R6, R8, tail
	ADDV	$1, R7
	JMP	tail

done:
	MOVV	R7, R4
	RET
